﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics;
using Infragistics.Win;

namespace WinGridMergeCells2
{
    public partial class Main : Form
    {
        public Main()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable table0 = new DataTable("Test");
            table0.Columns.Add("Wlid", typeof(int));          
            table0.Columns.Add("Headline", typeof(string));
            table0.Columns.Add("Order", typeof(int));
            table0.Columns.Add("Content", typeof(string));
           
            table0.Columns.Add("Section", typeof(string));
            table0.Columns.Add("Content_order", typeof(int));
            table0.Columns.Add("Section_order", typeof(int));

            table0.Rows.Add(12345, "Oshkosh Sales Driven by 25% Gain in Access Equipment", 1, "Overview", "Section1", 1, 1);
            table0.Rows.Add(12346, "Oshkosh Most Exposed to North America at 82% of Sales", 2, "Overview", "Section1", 1, 1);
            table0.Rows.Add(12347, "Oshkosh Sees 8% Margin in 2015 Led by Access Equipment", 3, "Overview", "Section2", 1, 3);
            table0.Rows.Add(12348, "Oshkosh Access Equipment 52% of Sales, 75% of Profit", 4, "Overview", "Section2", 1, 3);
            table0.Rows.Add(12349, "Oshkosh Access Equipment 7% Gain, Fire-Unit Surprise Boosts 1Q", 5, "Key", "Sec3", 5, 5);
            table0.Rows.Add(12341, "Terex, Linamar Are Top JLG Rivals in Access Equipment", 6, "Key", "Sec3", 5, 5);
            table0.Rows.Add(123451, "Aerial Growth May Slow After Record Sales Past Two Years", 7, "Key", "Sec4", 5, 7);
            table0.Rows.Add(123452, "Oshkosh Aerial Margins Surpass Terex as Outlook Diverges", 8, "Key", "Sec4", 5, 8);


            //table0.Rows.Add(12345,  "Oshkosh Sales Driven by 25% Gain in Access Equipment", 1, "", "", 0, 0);
            //table0.Rows.Add(12346, "Oshkosh Most Exposed to North America at 82% of Sales", 2, "", "", 0, 0);
            //table0.Rows.Add(12347, "Oshkosh Sees 8% Margin in 2015 Led by Access Equipment", 3, "", "", 0, 0);
            //table0.Rows.Add(12348, "Oshkosh Access Equipment 52% of Sales, 75% of Profit", 4, "", "", 0, 0);
            //table0.Rows.Add(12349, "Oshkosh Access Equipment 7% Gain, Fire-Unit Surprise Boosts 1Q", 5, "", "", 0, 0);
            //table0.Rows.Add(12341, "Terex, Linamar Are Top JLG Rivals in Access Equipment", 6, "", "", 0, 0);
            //table0.Rows.Add(123451, "Aerial Growth May Slow After Record Sales Past Two Years", 7, "", "", 0, 0);
            //table0.Rows.Add(123452, "Oshkosh Aerial Margins Surpass Terex as Outlook Diverges", 8, "", "", 0, 0);


            //table0.Rows.Add(123453, "Oshkosh Defense Competes With Navistar, General Dynamics", 9, "", "", 0, 0);
            //table0.Rows.Add(123454, "Army Humvee $27 Billion Do-Over Award Set for 3Q", 10, "", "", 0, 0);
            //table0.Rows.Add(123455, "Housing Main Driver of Oshkosh Concrete Mixer Sales", 11, "", "", 0, 0);
            //table0.Rows.Add(123456, "Rosenbauer Key Oshkosh Rival in Fire, Airport Products", 12, "", "", 0, 0);
            //table0.Rows.Add(123457, "Oshkosh Access Equipment, Commercial Sales Peak in 3Q", 13, "", "", 0, 0);
          

            ultraGrid1.DataSource = table0;        
         
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            UltraGridBand band = layout.Bands[0];
            UltraGridOverride ov = layout.Override;

            ov.GroupByColumnsHidden =Infragistics.Win.DefaultableBoolean.True;
         //   band.Columns["Headline"].GroupByEvaluator = new MyGroupByEvalautor();
            layout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;

            ultraGrid1.DisplayLayout.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.True;
            ultraGrid1.AllowDrop = true;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Section"].Width = 120;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Headline"].Width = 400;

            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Content"].Hidden = false;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Section"].Hidden = false;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Content_order"].Hidden = false;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Section_order"].Hidden = false;

            this.ultraGrid1.DisplayLayout.Override.GroupByColumnsHidden = DefaultableBoolean.False;

            this.ultraGrid1.ContextMenuStrip = this.contextMenuStrip1;

            this.ultraGrid1.DisplayLayout.GroupByBox.Hidden = true;
            this.ultraGrid1.DisplayLayout.Override.HeaderPlacement = Infragistics.Win.UltraWinGrid.HeaderPlacement.OncePerGroupedRowIsland;
            ////////Freez header;
            this.ultraGrid1.DisplayLayout.UseFixedHeaders = true;
            this.ultraGrid1.DisplayLayout.Override.ExpansionIndicator = ShowExpansionIndicator.CheckOnDisplay;
            this.ultraGrid1.DisplayLayout.Override.FixedHeaderIndicator = FixedHeaderIndicator.None;
            // set knwon column attributes
            this.ultraGrid1.DisplayLayout.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.True;

            foreach (UltraGridBand b in this.ultraGrid1.DisplayLayout.Bands)
            {
                foreach (UltraGridColumn ugc in b.Columns)
                {
                    ugc.CellActivation = Activation.NoEdit;
                    //ugc.Header.Appearance.BackColor = Color.Black;
                    //ugc.Header.Appearance.BackColor2 = Color.FromArgb(191, 219, 255);
                    //ugc.Header.Appearance.ForeColor = Color.White;
                }
            }

            ToggleView();

            //foreach (UltraGridBand sband in ultraGrid1.DisplayLayout.Bands)
            //{
            //    foreach (UltraGridColumn ugc in sband.Columns)
            //    {
            //        ugc.Header.Appearance.BackColor = Color.Black;
            //        ugc.Header.Appearance.BackColor2 =  Color.White;
            //        ugc.Header.Appearance.ForeColor = Color.FromArgb(191, 219, 255); 
            //    }
            //}

            //ultraGrid1.DisplayLayout.ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand.OutlookGroupBy;
            //ultraGrid1.DisplayLayout.ViewStyle = Infragistics.Win.UltraWinGrid.ViewStyle.MultiBand;
           
            //ultraGrid1.DisplayLayout.Override.AllowMultiCellOperations = AllowMultiCellOperation.Copy;

            //ultraGrid1.DisplayLayout.Override.CellClickAction = CellClickAction.CellSelect;

         
            //ultraGrid1.DisplayLayout.Override.RowSelectorWidth = 20;

            //// ultraGrid1.DisplayLayout.GroupByBox.Hidden = true;
            //ultraGrid1.DisplayLayout.Override.HeaderPlacement = Infragistics.Win.UltraWinGrid.HeaderPlacement.OncePerGroupedRowIsland;
            //////////Freez header;
            //ultraGrid1.DisplayLayout.UseFixedHeaders = true;
            //ultraGrid1.DisplayLayout.Override.ExpansionIndicator = ShowExpansionIndicator.CheckOnDisplay;
            //ultraGrid1.DisplayLayout.Override.FixedHeaderIndicator = FixedHeaderIndicator.None;
            //// set knwon column attributes
            //ultraGrid1.DisplayLayout.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.True;

            //this.ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add(ultraGrid1.DisplayLayout.Bands[0].Columns["col1"], false, true);

            //ultraGrid1.AllowDrop = true;

       
            
        }

    

        public class MyGroupByEvalautor : IGroupByEvaluator
        {
            #region IGroupByEvaluator Members

            bool IGroupByEvaluator.DoesGroupContainRow(UltraGridGroupByRow groupByRow, UltraGridRow row)
            {
                int value = (int)row.Cells[groupByRow.Column].Value;
                switch (groupByRow.Value.ToString())
                {
                    case "positive":
                        return value > 0;
                    case "negative":
                    default:
                        return value <= 0;
                }
            }

            object IGroupByEvaluator.GetGroupByValue(UltraGridGroupByRow groupByRow, UltraGridRow row)
            {
                int value = (int)row.Cells[groupByRow.Column].Value;
                if (value <= 0)
                    return "negative";
                else
                    return "positive";
            }

            #endregion
        }

        private void ToggleView()
        {

            if (button1.Text == "Regular View")
            {
                button1.Text = "Report View";
                //set group by
                // this.ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add("Order", false, true);
                this.ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add("Content_order", false, true);
                this.ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add("Section_order", false, true);
                // ov.GroupByColumnsHidden = Infragistics.Win.DefaultableBoolean.True;
                expandGrid(true);


            }
            else
            {
                button1.Text = "Regular View";
                //clear group by
                //  ov.GroupByColumnsHidden = Infragistics.Win.DefaultableBoolean.True;
                this.ultraGrid1.DisplayLayout.ClearGroupByColumns();
                this.ultraGrid1.Refresh();

            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ToggleView();
        }

        private void expandGrid(bool Expand)
        {

            List<UltraGridRow> rowCollection = this.ultraGrid1.Rows.GetAllNonGroupByRows().ToList<UltraGridRow>();
          
            foreach (UltraGridRow row in rowCollection)
            {
                //if (row.ChildBands.Count > 0)
                //{
                    if (Expand)
                    {
                        row.ExpandAll();
                        row.ExpandAncestors();

                    }
                    else
                    {
                        row.CollapseAll();
                        UltraGridGroupByRow grouprow = (UltraGridGroupByRow)row.ParentRow;
                        if (grouprow != null)
                        {
                            grouprow.CollapseAll();
                        }
                    }

                //}
            }


            //UltraGridRow row = this.ultraGrid1.Rows[0];

            //// Check to see if the row is expandable which depends on factors like whether
            //// the row has any child rows and whether the band associated with it is expandable.
            //// Return if the row is not expandable
            //if (!row.IsExpandable)
            //    return;

            //// Toggle the row's expanded status.
            //if (!row.Expanded)
            //{
            //    // Set the Expanded to true to expand the row.
            //    row.Expanded = true;
            //}
            //else
            //{
            //    // Set the Expanded to false to collapse the row.
            //    row.Expanded = false;
            //}

            this.ultraGrid1.Refresh();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (button1.Text == "Expand")
            {
                button1.Text = "Collapse";
               
                expandGrid(false);


            }
            else
            {
                button1.Text = "Expand";

                expandGrid(true);
            }
        }

        private void RefreshGrid()
        {
            //set group by
            // this.ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add("Order", false, true);
            this.ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add("Content_order", false, true);
            this.ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add("Section_order", false, true);
            // ov.GroupByColumnsHidden = Infragistics.Win.DefaultableBoolean.True;
            expandGrid(true);

        }

        private void toolStripMenuItem1_Click(object sender, EventArgs e)
        {
            InputText input = new InputText();

            input.ShowDialog();

            if (input.DialogResult == DialogResult.OK)
            {
                string context = input.UserInput;

                UltraGridRow row = this.ultraGrid1.ActiveRow;
                int order =Convert.ToInt32( row.Cells["Order"].Value.ToString());

                foreach (UltraGridRow r in this.ultraGrid1.Rows.GetFilteredInNonGroupByRows())
                {
                    //if (!r.IsGroupByRow)
                    //{
                        if (Convert.ToInt32(r.Cells["Order"].Value.ToString()) >= order)
                        {
                            r.Cells["Content"].Value = context;
                            r.Cells["Content_order"].Value = order;
                        }

                   // }
                }
                
               

                //get all rows after that
                RefreshGrid();
                


            }

        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            InputText input = new InputText();

            input.ShowDialog();

            if (input.DialogResult == DialogResult.OK)
            {
                string context = input.UserInput;

                UltraGridRow row = this.ultraGrid1.ActiveRow;
                int order = Convert.ToInt32(row.Cells["Order"].Value.ToString());
                string content = row.Cells["Content"].Value.ToString();
                foreach (UltraGridRow r in this.ultraGrid1.Rows.GetFilteredInNonGroupByRows())
                {
                    if (Convert.ToInt32(r.Cells["Order"].Value.ToString()) >= order && r.Cells["Content"].Value.ToString() == content)
                    {
                        r.Cells["Section"].Value = context;
                        r.Cells["Section_order"].Value = order;
                    }

                }

                RefreshGrid();



            }
        }

    }


   
}
